"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _promise = _interopRequireDefault(require("@babel/runtime/core-js/promise"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var webpack = require("webpack");

var HtmlWebpackPlugin = require("html-webpack-plugin");

exports.onCreateWebpackConfig =
/*#__PURE__*/
function () {
  var _ref2 = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee(args, _ref) {
    var modulePath, stage, getConfig, plugins, store, gatsbyWebpackConfig, cmsWebpackConfig, compiler, _store$getState, gatsbyConfig, developMiddleware;

    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            modulePath = _ref.modulePath;
            stage = args.stage, getConfig = args.getConfig, plugins = args.plugins, store = args.store;

            if (!(stage === "develop" || stage === "build-javascript")) {
              _context.next = 14;
              break;
            }

            gatsbyWebpackConfig = getConfig();
            cmsWebpackConfig = (0, _extends2.default)({}, gatsbyWebpackConfig, {
              optimization: undefined,
              // Fixes error in netlify-cms: Uncaught TypeError: Super expression must either be null or a function, not undefined
              mode: "none",
              entry: {
                cms: [__dirname + "/cms.js", modulePath].filter(function (p) {
                  return p;
                })
              },
              plugins: [plugins.extractText(), new HtmlWebpackPlugin({
                title: "Content Manager",
                filename: "admin/index.html",
                chunks: ["cms"]
              })]
            });
            compiler = webpack(cmsWebpackConfig);

            if (!(stage === "develop")) {
              _context.next = 12;
              break;
            }

            _store$getState = store.getState(), gatsbyConfig = _store$getState.config;

            developMiddleware = function developMiddleware(app) {
              var _gatsbyConfig$develop;

              (_gatsbyConfig$develop = gatsbyConfig.developMiddleware) === null || _gatsbyConfig$develop === void 0 ? void 0 : _gatsbyConfig$develop.call(gatsbyConfig, app);
              app.use(require("webpack-dev-middleware")(compiler, {
                logLevel: "trace",
                publicPath: cmsWebpackConfig.output.publicPath,
                stats: "errors-only"
              }));
            };

            store.dispatch({
              type: "SET_SITE_CONFIG",
              payload: (0, _extends2.default)({}, gatsbyConfig, {
                // Joy schema validation fails with pathPrefix = ''
                pathPrefix: gatsbyConfig.pathPrefix || undefined,
                developMiddleware: developMiddleware
              })
            });
            _context.next = 14;
            break;

          case 12:
            _context.next = 14;
            return new _promise.default(function (resolve, reject) {
              compiler.run(function (err, stats) {
                if (err) {
                  reject(err);
                  return;
                }

                var jsonStats = stats.toJson();

                if (jsonStats.errors && jsonStats.errors.length > 0) {
                  reject(jsonStats.errors);
                  return;
                }

                resolve();
              });
            });

          case 14:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x, _x2) {
    return _ref2.apply(this, arguments);
  };
}();